"use strict";
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------
Object.defineProperty(exports, "__esModule", { value: true });
const node_builder_1 = require("../node-builder");
const esotope_hammerhead_1 = require("esotope-hammerhead");
// Transform:
// location = value -->
// (function(){ return __set$Loc(location, value) || location = value;}.apply(this))
const transformer = {
    nodeReplacementRequireTransform: false,
    nodeTypes: esotope_hammerhead_1.Syntax.AssignmentExpression,
    condition: node => node.operator === '=' && node.left.type === esotope_hammerhead_1.Syntax.Identifier && node.left.name === 'location',
    run: (node, parent, key) => {
        if (!parent)
            return null;
        const wrapWithSequence = key !== 'arguments' && key !== 'consequent' && key !== 'alternate' &&
            // @ts-ignore
            (parent.type !== esotope_hammerhead_1.Syntax.SequenceExpression || parent.expressions[0] === node);
        return node_builder_1.createLocationSetWrapper(node.left, node.right, wrapWithSequence);
    }
};
exports.default = transformer;module.exports = exports.default;

