"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const generate_unique_id_1 = __importDefault(require("../../utils/generate-unique-id"));
class ConfigureResponseEvent {
    constructor(requestFilterRule, requestContext, opts) {
        this.requestFilterRule = requestFilterRule;
        this._requestContext = requestContext;
        this.opts = opts;
        this.id = generate_unique_id_1.default();
    }
    async setHeader(name, value) {
        if (!this._requestContext)
            return;
        this._requestContext.destRes.headers[name.toLowerCase()] = value;
    }
    async removeHeader(name) {
        if (!this._requestContext)
            return;
        delete this._requestContext.destRes.headers[name.toLowerCase()];
    }
    static from(data) {
        const { id, opts, requestFilterRule } = data;
        const configureResponseEvent = new ConfigureResponseEvent(requestFilterRule, null, opts);
        configureResponseEvent.id = id;
        return configureResponseEvent;
    }
}
exports.default = ConfigureResponseEvent;module.exports = exports.default;

