"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const generate_unique_id_1 = __importDefault(require("../../utils/generate-unique-id"));
class RequestEvent {
    constructor(requestFilterRule, requestContext, requestInfo) {
        this.requestFilterRule = requestFilterRule;
        this._requestContext = requestContext;
        this._requestInfo = requestInfo;
        this.id = generate_unique_id_1.default();
    }
    async setMock(mock) {
        var _a;
        await ((_a = this._requestContext) === null || _a === void 0 ? void 0 : _a.session.setMock(this.id, mock));
    }
    get requestOptions() {
        var _a;
        return (_a = this._requestContext) === null || _a === void 0 ? void 0 : _a.reqOpts;
    }
    get isAjax() {
        return this._requestInfo.isAjax;
    }
    static from(data) {
        const { id, requestFilterRule, _requestInfo } = data;
        const requestEvent = new RequestEvent(requestFilterRule, null, _requestInfo);
        requestEvent.id = id;
        return requestEvent;
    }
}
exports.default = RequestEvent;module.exports = exports.default;

