"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const generate_unique_id_1 = __importDefault(require("../../utils/generate-unique-id"));
class ResponseEvent {
    constructor(requestFilterRule, preparedResponseInfo) {
        const { requestId, statusCode, sessionId, isSameOriginPolicyFailed, headers, body } = preparedResponseInfo;
        this.requestId = requestId;
        this.statusCode = statusCode;
        this.sessionId = sessionId;
        this.isSameOriginPolicyFailed = isSameOriginPolicyFailed;
        this.headers = headers || this.headers;
        this.body = body || this.body;
        this.id = generate_unique_id_1.default();
        this.requestFilterRule = requestFilterRule;
    }
    static from(data) {
        const { requestFilterRule, id, requestId, statusCode, sessionId, isSameOriginPolicyFailed, headers, body } = data;
        const responseEvent = new ResponseEvent(requestFilterRule, {
            requestId,
            statusCode,
            sessionId,
            isSameOriginPolicyFailed,
            headers,
            body
        });
        responseEvent.id = id;
        return responseEvent;
    }
}
exports.default = ResponseEvent;module.exports = exports.default;

